import Acquisition
import ExtensionClass
import Persistence
import time
from Folder import Folder

class Folders(ExtensionClass.Base, Acquisition.Implicit, Persistence.Persistent):
	"""


	"""

	type = 'generic'
			
	def __init__(self, PARENTS):
		"""
		Initialisation
		
		"""
		print "Folders initted"
		self.PARENTS = PARENTS + [self]
	
	def keys(self):
		"""

			Returns the list of available data_types

		"""
		if not hasattr(self, '_keys'): 
			print "keys not cached!"
			self._keys = filter(self.testFolder, self.getFolders(self.PARENTS[0].conn)) 
		return self._keys

	def testFolder(self, folderName):
		"""
			This function can be voerloaded by subclasses to check
			that the folder name is actually a folder containing
			the relevant data for this data-type
		"""

	def testFolder(self, folderName):
		"""

		"""

		if (folderName != 'addressbook'):
			return 1
		else:
			return 0


    	def getFolders(self, start):
		returnValue = []
		if start.tpValues(1) == []:
			if hasattr(start, 'tpId'):
				returnValue = returnValue + [start.tpId()]
		else:
			for x in start.tpValues(1):
				returnValue = returnValue + self.getFolders(x)
		return returnValue

	

	def __getitem__(self, index):
		"""

		"""
		return Folder(self.PARENTS, index)



	  
	def delete(self, REQUEST):
        	""" Delete a mailbox """
		user = REQUEST['AUTHENTICATED_USER']
		# Remove the delete push putton thing from the form dictionary
		del REQUEST.form['delete']
		for x in REQUEST.form.keys():
			if REQUEST.form[x] == 'on':
				conn = user.conn.connection
				if conn.state == 'SELECTED':
					typ, c = conn.close()
				typ, c = conn.delete(x)
				typ, c = conn.unsubscribe(x) # Unsubscribe before deleting mailbox
		return self.imap_menu(self, REQUEST)

	    
	def create(self, REQUEST):
		""" Create a new mail box and subscribe to it """
		user = REQUEST['AUTHENTICATED_USER']
		# Remove the delete push putton thing from the form dictionary	

		conn = user.conn.connection
		typ, c = conn.create(REQUEST.form['newbox'])
		typ, c = conn.subscribe(REQUEST.form['newbox']) # Unsubscribe before deleting mailbox
		return self.imap_menu(self, REQUEST)




	    
	def rename(self, REQUEST):
		""" Rename first selected mailbox to new name """
		user = REQUEST['AUTHENTICATED_USER']
		# Remove the delete push putton thing from the form dictionary
		newName = REQUEST.form['newbox']
		del REQUEST.form['rename']
		oldName = REQUEST.form.keys()[1]
		conn = user.conn.connection
		if conn.state == 'SELECTED':    # if the connection has a box selected lets close it
			typ, c = conn.close()
		typ, c = conn.unsubscribe(oldName) #not sure if you need to do this but lets anyway
		typ, c = conn.rename(oldName, newName)
		typ, c = conn.subscribe(newName) # resubscribe to new name
		return self.imap_menu(self, REQUEST)











