import string
from imaplib import parse
from Imapmime import Imapmime

class Message:
	"""
	Allow us to do funky stuff with the flags :)
	"""

	def __init__(self, PARENTS,  init_string=None, uid=None):
		# Retrieve a list of flags
		self.PARENTS = PARENTS + [self]
		if not init_string:
			self.PARENTS[0].conn.connection.select(self.PARENTS[-2].id)
			err, res = self.PARENTS[0].conn.connection.uid("fetch" ,  uid, '(UID flags rfc822.size BODY[HEADER.FIELDS (SUBJECT FROM DATE TO CC X-PHONE REPLY-TO)])' )
			init_string=res[0]
		self.parse_summary_info(init_string)
	
	def getNext(self):
		"""
		REturns the next UID in a sequence if any
		"""

		try:
			return self.nextUID
		except:
			return None
	
	def setNext(self, UID):
		"""
		Sets the next UID a sequence
		"""
		self.nextUID = UID

	def hasNext(self):
		"""
			retruns true if there is a next  in the sequence
		"""
		return hasattr(self, 'nextUID')


	def getPrev(self):
		"""
		REturns the next UID in a sequence if any
		"""

		try:
			return self.prevUID
		except:
			return None

	def setPrev(self, UID):
		"""
		Sets the next UID a sequence
		"""
		self.nextUID = UID
	
	def hasPrev(self):
		"""
			retruns true if there is a next  in the sequence
		"""
		return hasattr(self, 'prevUID')




	def getSize(self):
		# formats the size nicely into bytes / kb or mb 
		# I don' think i'll need to worry about Gb :)
		
		if self.size < 1024:
			return "%db" % self.size 
		else:
			self.size = self.size / 1024

		if self.size < 1024:
			return "%3.2fkb" % self.size 
		else:
			return  "%3.2fMb" % (self.size / 1024)


	def getHeader(self, header):
		"""
		Try and get a header!
		"""
		header = string.upper(header)
		try:
			if type(self.headers[header]) == type(''):
				return  string.strip(self.headers[header])
			else:
				retVal = ''
				for x in  self.headers[header]:
					retVal = retVal + x
				return retVal
		except:
			return ''

	def hasFlag(self, flag):
		if flag in self.flags:
			return 1
		else:
			return None





	def render(self, REQUEST):
		"""
			Return a DTML page to view this object
		"""
		REQUEST['foldername'] = self.PARENTS[-2].id
		REQUEST['search'] = ''
		REQUEST['sort'] = 'DATE'
		REQUEST['reverse'] = '1'
		REQUEST['num_folders'] = '100'
		REQUEST['messageObject'] = self
		return self.PARENTS[0].render_object('%s_message' % self.PARENTS[-3].type, REQUEST)


	def parse_summary_info(self, input):

				returnValue = []
		#for x in input:
		#	if  len(x) == 2:
				(flags, headers) = input
				fls = string.split( flags, ' ', 4)
				uid = fls[2]

				fls2 = string.split(fls[4], ')', 1)

				flages = fls2[0][1:]
				flags = string.split(flages)
				size = string.atof(string.split(string.strip(fls2[1]), ' ', 2)[1])
				head={}
				for y in  string.split(string.strip(headers), '\n'):
					try:
						(label, value) = string.split(y, ':', 1)
						head[ string.upper(string.strip(label))] =  string.strip(value)
					except:
						pass
				self.flags = flags
				self.headers = head
				self.size = size
				self.UID = uid


	def render_body(self):
		"""
		This code renders the body of the object

		"""
		retVal=''
		imObj = self.getMimeObject()
		return imObj.render()

	def getMimeObject(self):
		self.PARENTS[0].conn.connection.select(self.PARENTS[-2].id)
		err, res = self.PARENTS[0].conn.connection.uid("fetch" ,  self.UID, '(BODY)' )
		print res
		ps =  parse(res[0])
		print ps
		print ps[0]
		print ps[1][0]
		for pos in range(0, len(ps[1])):
			if ps[1][pos] == 'BODY':
				body = ps[1][pos+1]
				break
		
		return Imapmime(self.PARENTS[0].conn.connection, self.PARENTS[-2].id, self.UID, '' ,body)
		
	def getRawData(self, part_num, RESPONSE=None):
		"""
			get sppecied mime part in raw binary data for display
		"""
		print part_num
		num = string.split(part_num , "_")
		num = num[1:]
		print num
		mo = self.getMimeObject()
		return mo[part_num].getRawData(RESPONSE)
		for parts in num:
			mo = mo[parts]
		return mo.getRawData(RESPONSE)

    

	def getBody(self):
		"""
		"""

		return self.getMimeObject().getBody()

	"""

		These message should proably moved somewhere esle. Possibly into the a subclass of Message class

		(displayMessage, display)
	"""

	    
	def displayMessage(self, mimeMess, uid, foldername, isMime=0, section=0):
		""" Convert a MIME message to HTML """
		""" is is somewhat dodgy, I probably should take advantage of
		imap's server side ability to parse MIME message
		"""

		



		return 'blah'
		if (mimeMess.getheader("MIME-Version") is not None) or isMime:
			maintype = mimeMess.getmaintype()
			if maintype == "text":
				return "<PRE>" + mimeMess.fp.read() + "</PRE>"
			elif maintype =="multipart":
				boundary = mimeMess.getparam("boundary")
				fp = multifile.MultiFile(mimeMess.fp, 0)
				
				fp.push(boundary)
				if not isMime:         # If we are still in and RFC822 message skip the preamble
					fp.read()
					fp.next()
				returnvalue = ""	
	
				while not fp.last:
					section = section + 1
					returnvalue = returnvalue + self.displayMessage(notmime.Message(fp), uid, foldername, 1, section)
					fp.next()
				return returnvalue

			elif maintype == "image":
				# Let's display the image!!! :)
				return '<IMG SRC="display?uid=' + uid + "&xamp;foldername=" + foldername + '&amp;section=' + str(section) + '">'
			else :
				description =  mimeMess.getdaram('filename')
				if description == "" or description is None: description = mimeMess.getparam('name')
				if description == "" or description is None: description = "(No Description)"
				return '<A HREF="display?uid=' + uid + "&amp;foldername=" + foldername + '&amp;section=' + str(section) + '">'  + description + " - " + mimeMess.gettype() + "</A> " + "<BR>"
		else:
			return "<PRE>" + mimeMess.fp.read() + "</PRE>"

	def display(self, uid, foldername,  section, REQUEST, RESPONSE):
		""" Convert a MIME message to HTML """

		""" is is somewhat dodgy, I probably should take advantage of
		imap's server side ability to parse MIME message
		"""

		user =  REQUEST['AUTHENTICATED_USER']

		mimeMess = user.imapGetUID(foldername, uid)

		section = string.atoi(section)

		if (mimeMess.getheader("MIME-Version") is not None):

		# TODO: Add features to this so that 
		
			maintype = mimeMess.getmaintype()
			if maintype == "text":
				return "<PRE>" + mimeMess.fp.read() + "</PRE>"
			elif maintype =="multipart":
				boundary = mimeMess.getparam("boundary")
				fp = multifile.MultiFile(mimeMess.fp, 0)
			
				fp.push(boundary)
				fp.read()
				fp.next()
						
				while not fp.last:
					section = section - 1
					if section == 0 :
						newMess = notmime.Message(fp)
						RESPONSE.setHeader('Content-Type', newMess.gettype())
						REQUEST['URL'] = "http://www.sesgroup.net:8090/somethingelse"
						return base64.decodestring(newMess.fp.read())
					else:
						fp.read()
					fp.next()
			else :
				description =  mimeMess.getdaram('filename')
				if description == "": description = "(No Description)"
				return '<A HREF="display?uid=' + uid + "&amp;folder=" + foldername + '&amp;section=' + str(section) + '">'  + description + " - " + mimeMess.gettype() + "</A> " + "<BR>"
		else:
			return "<PRE>" + mimeMess.fp.read() + "</PRE>"


